#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void
writeProgramBin(  size_t binary_size, char *binary,
                  char *filename )
{
    FILE *output = NULL;
    fprintf(stderr, "Writing out binary kernel to %s\n", filename );
    output = fopen( filename, "wb" );
    fwrite( binary, sizeof(char), binary_size, output );
    if( output == NULL )
	{
	  fprintf( stderr, "Unable to open %s for write. Exiting.\n",
                   filename );
          exit( -1 );
        }
    fclose( output );
}


int main(int argc, char *argv[]  )
{
    unsigned int i = 0,j=0,k,t;
    FILE * input = NULL;
    size_t size1 = 0;
    size_t size2 = 0;
    size_t size3 = 0;
    size_t size4 = 0;
    unsigned char * binary1 = NULL;
    unsigned char * binary2 = NULL;
    unsigned char * binary3 = NULL;
    unsigned char * binary4 = NULL;
    char *filename1,*filename2;
    unsigned int boolean;
    int ctr1=0;
    int ctr2=0;
    int ctr3=0;
    int ctr4=0;
    int ctr5=0;
    int ctr6=0;
    int ctr=0 ;
    int store1[500] ;
    int store2[500] ;
    size_t size;
    
    int isaStartA,isaStartB,fullIsaSz,precisionControl;
    
    if ( argc != 7 ) {printf("Error:getInnerElf:Too few arguments\n"); return 1; }
     else {   
	filename1 = argv[1] ;
	filename2 = argv[2] ;
	isaStartA = atoi(argv[3]);
	isaStartB = atoi(argv[4]);
	fullIsaSz = atoi(argv[5]);
	precisionControl = atoi(argv[6]);
     }   
   
	fprintf( stderr,"Reading in binary kernel from %s\n", filename1 );
        input = fopen( filename1, "rb" );
        if( input == NULL )
        {
            fprintf( stderr, "Unable to open %s for reading.\n", filename1 );
            
        }
        fseek( input, 0L, SEEK_END );    
        size1 = ftell( input );
        rewind( input );
        binary1 = (char *)malloc( size1 );
        fread( binary1, sizeof(char), size1, input );
        fclose( input );
	
	fprintf(stderr, "Reading in binary kernel from %s\n", filename2 );
        input = fopen( filename2, "rb" );
        if( input == NULL )
        {
            fprintf( stderr, "Unable to open %s for reading.\n", filename2 );
            
        }
        fseek( input, 0L, SEEK_END );    
        size2 = ftell( input );
        rewind( input );
        binary2 = (char *)malloc( size2 );
        fread( binary2, sizeof(char), size2, input );
        fclose( input );
	
	int isaEndA = isaStartA + fullIsaSz, isaEndB= isaStartB + fullIsaSz ;
	
	for(i=isaStartA;i<=isaEndA;i++){
	  for(j=isaStartB;j<=isaEndB;j++){
	    boolean = 0;
	   for(k=0;k<precisionControl;k++){
	     if(binary1[i+k]!=binary2[j+k]) {boolean=0;break;}
	     boolean = boolean|| binary1[i+k] ;
	     }
	     if(boolean){ printf("%d %d ",i,j);
	     while(binary1[i+k]==binary2[j+k]) k++;
	     for(t=j;t<(j+k);t++) binary2[t] = 0 ;
	     printf("%d\n",k-1);
	     i = i+k;
	     j = j+k;
	     ctr = ctr + k;
	    }
	    
	  }
	  
	}
	writeProgramBin(size2,binary2,filename2);  
	fprintf(stderr,"%d\n",ctr) ;

  return 0;
}


 
 
